var NCOWebtopForm = null; // gets set in init
var NCOWebtopFormName = "menuname";
var NCOWebtopWindowParams = "location=no,status=no,height=600,width=700,scrollbars=yes";
var NCOWebtopButtons = new Array();
NCOWebtopButtons[ 0 ] = "doModify";
NCOWebtopButtons[ 1 ] = "doDelete";

//****************************************************************************	
function doSubmitForm( target , formName )
{
	window.document.forms[ formName ].action = target;
	window.document.forms[ formName ].submit();
}

//****************************************************************************	
function NCOWebtopOpenPage( action , formName, componentName )
{
	var selectedIndex = null;
	var urlBase = document.location+"/";
	
	if ( action == "AddMenu/" )
	{
		urlBase += action ;
		window.open( urlBase , "menuEditWindow" , NCOWebtopWindowParams );	
	}
	else if ( NCOWebtopItemsSelected( formName , componentName ) )
	{
		// NBS 29291: menuName needs to be URL-encoded.
		var menuName = encodeURIComponent(
			NCOWebtopGetCurrentMenu( formName , componentName ) );

		urlBase += ( action + "?menuname=" +  menuName  );
		window.open( urlBase , "menuEditWindow" , NCOWebtopWindowParams );
	}
}

//****************************************************************************	
function NCOWebtopDoselectionUpdate( )
{
	if ( document.layers )
	{
		return;
	}
	else 
	{
		if ( NCOWebtopItemsSelected( "menus" , "menuname" ) )
		{
			NCOWebtopUpdateButtons( false );
		}
		else
		{
			NCOWebtopUpdateButtons( true );
		}
	}	
}

//****************************************************************************	
function NCOWebtopUpdateButtons( update )
{
	var size = NCOWebtopButtons.length;
	var i = 0;
	for ( i = 0 ; i < size ; i++ )
	{
		NCOWebtopForm.elements[ NCOWebtopButtons[ i ] ].disabled = update;
	}
}

//****************************************************************************	
function NCOWebtopGetCurrentMenu( formName , componentName )
{
	var selectedIndex = NCOWebtopGetSelectedIndex( formName , componentName );
	return document.forms[ formName ][ componentName ].options[ selectedIndex ].value;	
}

//****************************************************************************	
function NCOWebtopGetSelectedIndex( formName , componentName )
{
	return document.forms[ formName ][ componentName ].options.selectedIndex;
}

//****************************************************************************	
function NCOWebtopItemsSelected( formName , componentName )
{
	return ( document.forms[ formName ][ componentName ].options.selectedIndex  > -1 );
}

//****************************************************************************	
function NCOWebtopAddMenu( menuName , menuLabel )
{
	var newOption = null;
	if ( NCOWebtopMenuExists( menuName ) )
	{
		return;
	}	
	var insertPoint = NCOWebtopGetInsertionPoint( menuName );
	NCOWebtopShiftDown( insertPoint );
	newOption = new Option( menuLabel , menuName , false, false );
	NCOWebtopForm.elements[ NCOWebtopFormName ].options[ insertPoint ] = newOption;
	NCOWebtopDoselectionUpdate( );
}

document.NCOWebtopAddMenu = NCOWebtopAddMenu;

//****************************************************************************	
function NCOWebtopRemoveMenu( menuName )
{
	var index = -1;
	if ( ( index = NCOWebtopGetElementIndex() ) != -1 )
	{
		NCOWebtopShiftUp( index );
	}
}
document.NCOWebtopRemoveMenu = NCOWebtopRemoveMenu;

//****************************************************************************	
function NCOWebtopMenuExists( menuName )
{
	var size = NCOWebtopMenusCount();
	var i = 0;
	for ( i = 0 ; i < size ; i++ )
	{
		if ( NCOWebtopForm.elements[ NCOWebtopFormName ].options[ i ].value == menuName )
		{
			return true;
		}
	}
	return false;
}

//****************************************************************************	
//
//
function NCOWebtopInit()
{
	NCOWebtopForm = document.forms[ "menus"];
	NCOWebtopDoselectionUpdate( );
}

//****************************************************************************	
function NCOWebtopMenusCount()
{
	return NCOWebtopForm.elements[ NCOWebtopFormName ].options.length;
}

//****************************************************************************	
function NCOWebtopGetInsertionPoint( name )
{
	var size = NCOWebtopMenusCount();
	var currValue = null;
	var i = 0;
	for ( i = 0 ; i < size ; i++ )
	{
		currValue = NCOWebtopForm.elements[ NCOWebtopFormName ].options[ i ].value;
		if ( currValue > name )
		{
			return i;
		}
	}
	return i;
}

//******************************************************************************************
function NCOWebtopRemoveMenu( menuName )
{
	var newOption = null;
	var deletePoint = -1;
	if ( ( deletePoint = NCOWebtopGetMenusIndex( menuName ) ) == -1 )
	{
	}
	else
	{
		NCOWebtopShiftUp( deletePoint );
	}
	NCOWebtopDoselectionUpdate( );	
}
document.NCOWebtopRemoveMenu = NCOWebtopRemoveMenu;

//****************************************************************************	
function NCOWebtopShiftDown( from )
{
	var size = NCOWebtopMenusCount();
	NCOWebtopForm.elements[ NCOWebtopFormName ].options.length++;
	var i = 0;

	for ( i = size  ; i > from ; i-- )
	{
		NCOWebtopForm.elements[ NCOWebtopFormName ].options[ i ] = NCOWebtopCloneElement( NCOWebtopFormName, i - 1);
	}

}

//****************************************************************************	
function NCOWebtopGetMenusIndex( name )
{
	var size = NCOWebtopMenusCount();
	var currValue = null;
	var i = 0;
	for ( i = 0 ; i < size ; i++ )
	{
		currValue = NCOWebtopForm.elements[ NCOWebtopFormName ].options[ i ].value;
		if ( currValue == name )
		{
			return i;
		}
	}
	return -1;
}
//****************************************************************************	
function NCOWebtopShiftDown( from )
{
	var size = NCOWebtopMenusCount();
	NCOWebtopForm.elements[ NCOWebtopFormName ].options.length++;
	var i = 0;

	for ( i = size  ; i > from ; i-- )
	{
		NCOWebtopForm.elements[ NCOWebtopFormName ].options[ i ] = NCOWebtopCloneElement( NCOWebtopFormName, i - 1);
	}

}

//****************************************************************************	
function NCOWebtopShiftUp( from )
{
	var size = NCOWebtopMenusCount();
	var i = 0;
	for ( i = from ; i < size-1; i++ )
	{
		NCOWebtopForm.elements[ NCOWebtopFormName ].options[ i ] = NCOWebtopCloneElement( NCOWebtopFormName, i + 1 );
	}
	NCOWebtopForm.elements[ NCOWebtopFormName ].options.length--;
}

//****************************************************************************	
function NCOWebtopGetElementIndex( name )
{
	var count = NCOWebtopMenusCount();
	if ( count < 1 )
	{
		return -1;
	}
	var currValue = null;
	var i = 0;
	for (  i = 0; i < count ; i++ )
	{
		currValue = NCOWebtopForm.elements[ NCOWebtopFormName ].option[ i ].value;
		if ( currValue == name )
		{
			return i;
		}
	}
	return -1;
}

//************************************************************************************************
function NCOWebtopCloneElement( formElementName , index )
{
	var text = NCOWebtopForm.elements[ formElementName ][ index ].text;
	var value = NCOWebtopForm.elements[ formElementName ][ index ].value;
	var option = new Option( text , value , false , false );
	return option;
}
