<%@ page language="java" contentType="text/html; charset=UTF-8" session="true" %>
<%@ page errorPage="errorpage.jsp" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jstl/core" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jstl/fmt" %>
<%@ taglib uri="/WEB-INF/tld/struts-bean.tld" prefix="bean" %>
<%@ taglib uri="/WEB-INF/tld/struts-html.tld" prefix="html" %>
<jsp:useBean id="user" class="com.micromuse.wave.fvbuilder.WebtopUser" scope="session" />
<jsp:useBean id="ncwin" class="com.micromuse.ncw.beans.NCWI18NSupport" scope="page"/>

<c:set target="${pageScope.ncwin}" value="${pageContext.session}" property="session"/>
<c:set target="${pageScope.ncwin}" value="filterviewbuilder" property="resourcename"/>
<c:set var="bundle" value="${pageScope.ncwin.bundlename}"/>
<fmt:setBundle basename="${bundle}" var="langset" scope="request"/>

<% String type = request.getParameter("type"); %>

<html:html locale="true">
<head>
<meta http-equiv=Content-Type content="text/html; charset=utf-8">
<META HTTP-EQUIV="expires" CONTENT="0">

<html:base/>
	<link rel=stylesheet TYPE="text/css"  href="../lwsel/style.css" title="Default">	
	<link rel=stylesheet TYPE="text/css"  href="../lwsel/master.css" title="Default">
	<script language="javascript" src="scripts/toolbar.jsp">
	</script>

</head>

<body bgcolor="#EEEEEE" style="padding: 0px; scrollbar-base-color: #CCCCCC; background-image: url(../lwsel/images/white_scan_lines.png)">

<table width="100%" cellpadding="0" border="0" cellspacing="0" class="TBLHeader" style="top: 0px;">
	<tr>
		<td align="left">
			<table cellpadding="0" border="0" cellspacing="0">
				<tr>


			<%if("admin".equals(user.getRole())) {%>
				
					<td>
						<button class="WTtoolbarButton" onclick="javascript:createFilter()"><img src="images/new.gif" border="0" alt="<fmt:message key="toolbar.filter.new" bundle="${langset}"/>" height="16" width="16"></button>
					</td>

					<td> 
						<button class="WTtoolbarButton" id="WRFrozenButton" onclick="javascript:copyFilter()"  height="16" width="16"><img src="images/copy.gif" border="0" alt="<fmt:message key="toolbar.filter.copy" bundle="${langset}"/>"></button>
					</td>
					<td>
						<button class="WTtoolbarButton" id="WRFrozenButton" onclick="javascript:delFilter()" height="16" width="16"><img src="images/button_delete.png" border="0" alt="<fmt:message key="toolbar.filter.delete" bundle="${langset}"/>"></button>
					</td>

			
			<%}else{
				
				if(type == null || "My Filters".equals(type)) {%>
		
					<td>
						<button class="WTtoolbarButton" onclick="javascript:createFilter()"><img src="images/new.gif" border="0" alt="<fmt:message key="toolbar.filter.new" bundle="${langset}"/>" height="16" width="16"></button>
					</td>

					<td> 
						<button class="WTtoolbarButton" id="WRFrozenButton" onclick="javascript:copyFilterToMyDir()"  height="16" width="16"><img src="images/copy.gif" border="0" alt="<fmt:message key="toolbar.filter.copy" bundle="${langset}"/>"></button>
					</td>
					<td>
						<button class="WTtoolbarButton" id="WRFrozenButton" onclick="javascript:delFilter()" height="16" width="16"><img src="images/button_delete.png" border="0" alt="<fmt:message key="toolbar.filter.delete" bundle="${langset}"/>"></button>
					</td>
				<%}else{%>
					<td> 
						<button class="WTtoolbarButton" id="WRFrozenButton" onclick="javascript:copyFilterToMyDir()"  height="16" width="16"><img src="images/copy.gif" border="0" alt="<fmt:message key="toolbar.filter.copy" bundle="${langset}"/>"></button>
					</td>
				<%}
			}%>
	<td>
		
	</td>				     

				

				</tr>
			</table>
		</td>

		<td align="right">
			<button class="WTtoolbarButton" id="WRFrozenButton" onclick="window.open('/help/webtop/nco-webtop.htm#nco_webtop_active_event_list/ael_filter_builder_introduction.htm', 'help'); " height="16" width="16"><img src="../lwsel/images/help.gif" border="0" alt="<fmt:message key="toolbar.alt.help" bundle="${langset}"/>"></button>
		</td>
	</tr>
</table>

</body>
</html:html>
