var WTFrozen = false;
var WTTimeOut = null;

var WTSelectedRows = null;
var WTSelectedRowsBaseClass = null;
var WTOldSelectedRows = new Array();
var WTOldSelectedRowsBaseClass = new Array();
var WTSelectedRowSerials = null;
var WTSelectedAll = null;
var WTSelectedAllBaseClass = null;

/******************************************************************************************
 *
 */
function init()
{
  setDisbleUnquickFilter();
  startPageTimer();

  try {
	event;
  }catch(err) {//add event listener for netscape

	var eventTable = document.getElementById( "WTLWSELToolbar" );
	if ( eventTable != null )
	{
		var eventRow = eventTable.getElementsByTagName( "TR" );
		for(var r=1; r<eventRow.length; r++) {

			eventRow[r].addEventListener("mousedown" , NSMouseDown, false);
			eventRow[r].addEventListener("mouseover", NSMouseOver, false);
			eventRow[r].addEventListener("mouseup", NSMouseUp, false);
		}
	}
   }
}

/******************************************************************************************
 *
 */
function NSMouseDown(e) {

	initWTSelectedRow( e.currentTarget, e );

}

/******************************************************************************************
 *
 */
function NSMouseOver(e) {

	getSelectedRow(e.currentTarget);

}

/******************************************************************************************
 *
 */
function NSMouseUp(e) {
	setSelectedRow(e.currentTarget);
}
/******************************************************************************************
 *
 */
function drawArrow(column) {


 var oldDirection = document.forms[ "lwselform" ].elements[ "sortcolumndir" ].value;
 var oldSortColumn = document.forms[ "lwselform" ].elements[ "sortcolumnfield" ].value;

 if(oldDirection != null && oldSortColumn != null && oldSortColumn == column) {

   	if(oldDirection == "asc") {
	
		img = "<img src='images/arrow_up.png' align='top' width='6'/>";

   	}else if(oldDirection == "desc") {
	
		img = "<img src='images/arrow_down.png' align='top' width='6'/>";
  	}
  
  document.write( img );
 }

}

/******************************************************************************************
 *
 */
function selectAllRows()
{
  var alertsTable = document.getElementById( "WTLWSELToolbar" );
  var tRows = alertsTable.getElementsByTagName( "TR" );
  var numOfRows = tRows.length;

  if(WTOldSelectedRows != null ) {
	resetOldSelected();
  }

  if( WTSelectedAll == null ) {

    WTSelectedAll = new Array();
    WTSelectedAllBaseClass = new Array();

  }else {
	
     clearAllSelectedRows();
     return;
  }

  WTSelectedRowSerials = new Array();

  for ( var i = 1; i < numOfRows ; i++ )
  {
   var children = tRows[ i ].getElementsByTagName( "TD" );  
   
   WTSelectedRowSerials[i-1] = tRows[ i ].id;
   WTSelectedAll[i-1] = tRows[ i ];
   WTSelectedAllBaseClass[i-1] = tRows[ i ].className;
   WTOldSelectedRows[i-1] = WTSelectedAll[i-1];
   WTOldSelectedRowsBaseClass[i-1] = WTSelectedAllBaseClass[i-1];

   tRows[ i ].className = "WTSelectedRow";

   for ( var j = 0 ; j < children.length ; j++ )
    {
      children[ j ].className = "WTSelectedRow";
    }
  }
}

/******************************************************************************************
 *
 */
function clearAllSelectedRows()
{
  var numOfSelectedRows = WTSelectedAll.length;

  for ( var n = 0; n < numOfSelectedRows; n++ )
  {
   clearSelect(WTSelectedAll[n], WTSelectedAllBaseClass[n]);
  }
  WTSelectedAllBaseClass = null;
  WTSelectedAll = null;
}

/******************************************************************************************
 *
 */
function clearSelect(row, baseClass)
{
  var children = row.getElementsByTagName( "TD" );
  row.className = baseClass;
  for ( i = 0 ;  i < children.length ; i++ )
    {
      children[ i ].className = baseClass;
    } 
  row.className = baseClass;
}

/******************************************************************************************
 *
 */
function initWTSelectedRow( row, evnt ) {

    var rightClick = false;

    try {
	if( event.button == 2) {

		rightClick = true;

	}else {
		rightClick = false;
	}

     }catch(err) {//ns version

	if(evnt.which == 3) {

		rightClick = true;

	}else {
		rightClick = false;
	}	
     }

     if(rightClick) {

		if( WTSelectedRowSerials == null ) return;

		var dataSource = document.forms[ "lwselform" ].elements[ "datasource" ].value;
		showEventDetails(row.id, dataSource);
     }else{

	     if( WTSelectedAll != null ) clearAllSelectedRows();
	     if(WTOldSelectedRows != null ) {
		resetOldSelected();
	     }
     
	     WTSelectedRows = new Array();
	     WTSelectedRowsBaseClass = new Array();
	     WTSelectedRows[0] = row;
	     WTSelectedRowsBaseClass[0] = row.className;
     }
}

/******************************************************************************************
 *
 */
function isContained(id, serials) {

	for ( var i = 0; i < serials.length; i++ )
   	{
		if(id == serials[i]) return true;
	}
	return false;
}


/******************************************************************************************
 *
 */
function setSelectedRow(row) {

   if( WTSelectedRows == null ) return;
   WTSelectedRowSerials = new Array();

   var j = 0;

   for ( var i = 0; i < WTSelectedRows.length; i++ )
   {

	var rowId = WTSelectedRows[i].id;

	if( i>0 && isContained(rowId, WTSelectedRowSerials) ) {
		continue;
	}

        WTSelectedRowSerials[j] = rowId;

	WTOldSelectedRows[j] = WTSelectedRows[i];

	WTOldSelectedRowsBaseClass[j] = WTSelectedRowsBaseClass[i];

	WTSelectedRows[i].className = "WTSelectedRow";

 	var children = WTSelectedRows[i].getElementsByTagName( "TD" );  
   
    	for ( var c = 0 ; c < children.length ; c++ )
    	{
      		children[ c ].className = "WTSelectedRow";
    	}
	j++;
   }
   WTSelectedRowSerials = WTSelectedRowSerials.sort();
   WTSelectedRows = null;
   WTSelectedRowsBaseClass = null;
}

/******************************************************************************************
 *
 */
function getSelectedRow(row) {

  if( WTSelectedRows == null ) return;

   var len = WTSelectedRows.length++;

   WTSelectedRows[len] = row;
   WTSelectedRowsBaseClass[len] = row.className;
}

/******************************************************************************************
 *
 */
function resetOldSelected()
{

  for(var w=0; w<WTOldSelectedRows.length; w++) {

	var children = WTOldSelectedRows[w].getElementsByTagName( "TD" );
  	WTOldSelectedRows[w].className = WTOldSelectedRowsBaseClass[w];

  	for ( i = 0 ;  i < children.length ; i++ )
    	{
		children[ i ].className = WTOldSelectedRowsBaseClass[w];
    	} 
  	WTOldSelectedRows[w].className = WTOldSelectedRowsBaseClass[w];
   }
   WTOldSelectedRows = new Array();
   WTOldSelectedRowsBaseClass = new Array();
}


/******************************************************************************************
 *
 */
function startPageTimer()
{
  var refreshSecs = document.forms[ "lwseluserparams" ].elements[ "userrefreshtime" ].value ;
  WTTimeOut = setTimeout( doRefresh , ( refreshSecs * 1000 ) );
}

/******************************************************************************************
 *
 */
function clearPageTimer()
{
  if ( WTTimeOut != null )
    {
      clearTimeout( WTTimeOut );
    }
}

/******************************************************************************************
 *
 */
function handleKeyPress()
{
  var keyCode = null;
  if ( event.ctrlKey == true )
    {
      if ( event.keyCode == 26 )
	{
	  toggleFrozen();
	}
    }
  else
    {
      event.cancelBubble = true;
      event.returnValue = false;
    }
}

/******************************************************************************************
 *
 */
function setDisbleUnquickFilter()
{
  if ( document.forms[ "lwselform" ].elements[ "quickfilterop" ].value == "" ||
       document.forms[ "lwselform" ].elements[ "quickfilterfield" ].value == "" ||
       document.forms[ "lwselform" ].elements[ "quickfiltervalue" ].value == "" )
    {
      document.getElementById( "clearQuickFilterButton" ).disabled = true ;
    }
}

/******************************************************************************************
 *
 */
function getIndex(serial) {

	if(WTSelectedRowSerials == null) return 0;

	for ( var i = 0; i < WTSelectedRowSerials.length; i++ )
   	{
		if(WTSelectedRowSerials[i] == serial) {
			return i;
		}
	}
}

/******************************************************************************************
 *
 */
function showEventDetails( rowId, dataSource )
{

  var serial = rowId.substring(rowId.indexOf("_") + 1);

  var idx = getIndex(rowId);

  var queryString = "datasource=" + dataSource + "&currentserial=" + serial+ "&serial=" + serial;

  if(idx == 0) {
	if(WTSelectedRowSerials.length > 1 ) {
	
  		queryString = queryString + "&serials=" + WTSelectedRowSerials + "&nextserial=" + WTSelectedRowSerials[idx+1];
	}
  }else {

	queryString = queryString + "&serials=" + WTSelectedRowSerials + "&prevserial="+ WTSelectedRowSerials[idx-1];

	if(idx != (WTSelectedRowSerials.length - 1) ) {
		queryString = queryString + "&nextserial=" + WTSelectedRowSerials[idx+1];
	}
  }

  //alert("query "+ queryString);

  window.open( "eventdetails.jsp?" + queryString , "eventdetails" , "status=no,location=no,width=550,height=650" );
}

/******************************************************************************************
 *
 */
function toggleFrozen()
{
  if ( WTFrozen == true )
    {
      setFrozenButtonOff();
      startPageTimer();
    }
  else
    {
      setFrozenButtonOn();
      clearPageTimer();
    }
  WTFrozen = !WTFrozen;
}

/******************************************************************************************
 *
 */
function getHostString()
{
  return window.location.host;
}

/******************************************************************************************
 *
 */
function setFrozenButtonOn()
{
  var button = document.getElementById( "WRFrozenButton" );
  button.className = "WTtoolbarButton_depressed";
}

/******************************************************************************************
 *
 */
function setFrozenButtonOff()
{
  var button = document.getElementById( "WRFrozenButton" );
  button.className = "WTtoolbarButton";
}

/******************************************************************************************
 *
 */
function goToPage( start )
{
  if ( !WTFrozen )
    {
      document.forms[ "lwselform" ].elements[ "start" ].value=start;
      document.forms[ "lwselform" ].submit();
    }
}


/******************************************************************************************
 *
 */
function doRefresh()
{
  if ( !WTFrozen )
    {
      document.forms[ "lwselform" ].submit();	
    }
}


/******************************************************************************************
 *
 */
function clearQuickFilter()
{
  if ( !WTFrozen )
    {
      doQuickFilter( ""  , "" , "" );
      document.forms[ "lwselform" ].submit();	
    }
}


/******************************************************************************************
 *
 */
function doQuickFilter( quickfilterop , quickfilterfield , quickfiltervalue )
{	
  if ( !WTFrozen )
    {
      document.forms[ "lwselform" ].elements[ "quickfilterop" ].value = quickfilterop;
      document.forms[ "lwselform" ].elements[ "quickfilterfield" ].value = quickfilterfield;
      document.forms[ "lwselform" ].elements[ "quickfiltervalue" ].value = quickfiltervalue;
      document.forms[ "lwselform" ].submit();		
    }	
}


/******************************************************************************************
 *
 */
function doColumnSort( columnName )
{
  if ( WTFrozen )
    {
      return;
    }
  var direction = "asc";

  var oldSortColumn = document.forms[ "lwselform" ].elements[ "sortcolumnfield" ].value;
  var oldDirection = document.forms[ "lwselform" ].elements[ "sortcolumndir" ].value;

    if ( columnName ==  oldSortColumn )
      {
	if ( oldDirection == "asc" )
	{
	  direction = "desc";

	}else if ( oldDirection == "desc" )
	{
	  //restore to original values
	  direction =  columnName = "";
	}
	else if ( oldDirection == "desc" )
	{
	  direction = "";
	}
      }

  document.forms[ "lwselform" ].elements[ "sortcolumnfield" ].value = columnName;
  document.forms[ "lwselform" ].elements[ "sortcolumndir" ].value = direction;
  document.forms[ "lwselform" ].submit();

  
}
