<%@ page language="java" contentType="text/javascript; charset=utf-8" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jstl/core" %>

/******************************************************************************************
 *
 */
function createView() {

 var viewForm = window.parent.frames[ 'sidebar' ].viewlist.document.viewForm;

 viewForm.action = '/createView.do';
 viewForm.target = 'main';
 viewForm.submit();

 buttonurl = "/viewbuilder/buttonbar.jsp?action=Copy";

 buttonframe  = window.parent.frames[ 'buttonbar' ].name;

 window.open(buttonurl, buttonframe);
 
} 


/******************************************************************************************
 *
 */
function copyView() {
  
 var idx = window.parent.frames[ 'sidebar' ].viewlist.document.viewForm.viewlist.selectedIndex;

  if(idx < 0) {
    alert("No view was selected.");
    return;
  }

  submitFormExec('viewForm',
                 'copyto.jsp',
                 'copy_view',
		 'main');

}

/******************************************************************************************
 *
 */
function copyViewToMyDir() {

  var idx = window.parent.frames[ 'sidebar' ].viewlist.document.viewForm.viewlist.selectedIndex;
  if(idx < 0) {
    alert("No view was selected.");
    return;
  }

 submitFormExec('viewForm',
                '/copyView.do',
                'copy_view',
		'main');

  
 buttonurl = "/viewbuilder/buttonbar.jsp?action=Copy";

 buttonframe  = window.parent.frames[ 'buttonbar' ].name;

 window.open(buttonurl, buttonframe);

}

/******************************************************************************************
 *
 */
function delView() {

  // verify that there is a selection to delete in the first place
  var idx = window.parent.frames[ 'sidebar' ].viewlist.document.viewForm.viewlist.selectedIndex;

  var len = window.parent.frames[ 'sidebar' ].viewlist.document.viewForm.viewlist.length;

  if(idx < 0) {
    alert("No view was selected.");
    return;
  }
  else if(len == 1) {

    alert("You cannot delete the last view.");

    return;

  }else	{
    if(!confirm("Are you sure you want to delete view\n\"" +
                  window.parent.frames[ 'sidebar' ].viewlist.document.viewForm.viewlist.options[idx].value +
                  "\"?")) {
      return;
    }
  }

  var deleteviewname = window.parent.frames[ 'sidebar' ].viewlist.document.viewForm.viewlist.options[idx].value;

  // set deleteview
  window.parent.frames[ 'sidebar' ].viewlist.document.viewForm.selectedview.value = deleteviewname;

  // update selectedview to 
  //   1. the row below
  //   2. the row above
  //   3. <blank> (in case of empty list)
  var size = window.parent.frames[ 'sidebar' ].viewlist.document.viewForm.viewlist.options.length;
  if((size - 1) >= (idx+1)) {   // there is an item below the deleted
    window.parent.frames[ 'sidebar' ].viewlist.document.viewForm.selectedview.value =
          window.parent.frames[ 'sidebar' ].viewlist.document.viewForm.viewlist.options[idx+1].value;
  }
  else if(idx > 0) {            // there is an item before the deleted
    window.parent.frames[ 'sidebar' ].viewlist.document.viewForm.selectedview.value =
          window.parent.frames[ 'sidebar' ].viewlist.document.viewForm.viewlist.options[idx-1].value;
  }
  else {                        // the deleted was the last item in the list
    window.parent.frames[ 'sidebar' ].viewlist.document.viewForm.selectedview.value = "";
  }

  // submit   
  submitFormExec('viewForm',
               '/saveView.do?action=Delete',
               'del_view',
	       'messages');

}

/******************************************************************************************
 * execute action
 */
function submitFormExec(form, href, execute, target) {

  presubmit_updateViewListItem();

  eval("window.parent.frames[ 'sidebar' ].viewlist.document."+form+".action = href ");
  eval("window.parent.frames[ 'sidebar' ].viewlist.document."+form+".exec.value = execute");
  eval("window.parent.frames[ 'sidebar' ].viewlist.document."+form+".target = '" + target + "'");
  eval("window.parent.frames[ 'sidebar' ].viewlist.document."+form+".submit()");

}

/******************************************************************************************
 * before a submit, need to fill in the hidden values for the viewlistitem#=""
 * to correspond to the current viewlist items
 */
function presubmit_updateViewListItem() {

  var numitems = window.parent.frames[ 'sidebar' ].viewlist.document.viewForm.viewlist.length;

  var i;
  var itemval;

  for(i = 0; i < numitems; i++) {

    if(window.parent.frames[ 'sidebar' ].viewlist.document.viewForm.viewlist.options[i]) {
      itemval = window.parent.frames[ 'sidebar' ].viewlist.document.viewForm.viewlist.options[i].value;
      if(itemval==null) { itemval = ""; }
    }

  } // endfor i numitems
  
} 
