	var baseForm = null;

	var NCOWebtopViewDisplay = null;
	var NCOWebtopSortDisplay = null;

	var NCOWebtopAvailableFields = null;
	var NCOWebtopEventListView = null;

	var NCOWebtopAvailableSortFields = null;	
	var NCOWebtopSortedBy = null;

	var NCOWebtopAvailableFieldsList = null;
	var NCOWebtopEventListView = null;

	var NCOWebtopAvailableSortFieldsList = null;	
	var NCOWebtopSortedByList = null;

	var NCOWebtopSelectData = new Array();
	var NCOWebtopUnusedData = new Array();


	//******************************************************
	function encodeFormData()
	{
		encodeBaseData( baseForm.elements[ "data" ] );
		NCOWebtopEventListViewList.encode( baseForm.elements[ "data" ] , "columns" );

		NCOWebtopSortedByList.encode( baseForm.elements[ "data" ] , "sorting" );

		closeBaseData(  baseForm.elements[ "data" ] );

	}



	//******************************************************
	function encodeBaseData( formElement )
	{
		var value = formElement.value;
		var string = "view(";		

		string += ( "viewName=\"" +  baseForm.elements[ "viewName" ].value + "\"," );
		string += ( "os=\"" + getOsName() + "\" )\n{\n" );
		value += string;
		formElement.value = value;
	}

	//******************************************************
	function closeBaseData( formElement )
	{
		var value = formElement.value;
		var string = "}";
		value += string;
		formElement.value = value;
	}

	//******************************************************
	function getOsName()
	{
		var index = baseForm.elements[ "os" ].selectedIndex;
		return baseForm.elements[ "os" ].options[ index ].value;
	}

	//******************************************************
	function initForms()
	{

		baseForm = document.forms[ 0 ];

		NCOWebtopViewDisplay = new NCOWebtopEventListViewDisplayFields( baseForm.elements[ "fieldName" ] , baseForm.elements[ "fieldNameJustify" ] ,
					baseForm.elements[ "columnTitle" ] , baseForm.elements[ "columnTitleJustify" ] , 
					baseForm.elements[ "columnWidth" ] );
		NCOWebtopViewDisplay.setName( "NCOWebtopViewDisplay" );

		NCOWebtopSortDisplay = new NCOWebtopSortedByDisplayFields(  baseForm.elements[ "sortFieldName"] , baseForm.elements[ "sort" ] );

		NCOWebtopSortDisplay.setName( "NCOWebtopSortDisplay" );
		
		// display columns
		NCOWebtopAvailableFields = new NCOWebtopFormElement( baseForm.elements[ "availableFields" ] );
		NCOWebtopAvailableFields.setDisplayElements( null );
		NCOWebtopAvailableFields.setName( "NCOWebtopAvailableFields" );

		NCOWebtopEventListView = new NCOWebtopFormElement( baseForm.elements[ "eventListView" ] );
		NCOWebtopEventListView.setDisplayElements( NCOWebtopViewDisplay );
		NCOWebtopEventListView.setName( "NCOWebtopEventListView" );


		// sort columns	
		NCOWebtopAvailableSortFields = new NCOWebtopFormElement( baseForm.elements[ "availableSortFields" ] );
		NCOWebtopAvailableSortFields.setDisplayElements( null );
		NCOWebtopAvailableSortFields.setName( "NCOWebtopAvailableSortFields" );
	
		NCOWebtopSortedBy = new NCOWebtopFormElement( baseForm.elements[ "sortFields" ] );
		NCOWebtopSortedBy.setDisplayElements( NCOWebtopSortDisplay );
		NCOWebtopSortedBy.setName( "NCOWebtopSortedBy" );
		
	}

	//******************************************************
	function NCOWebtopInit()
	{

		initForms();
		createLists();
		addItems();
	}

	//******************************************************
	function createLists()
	{

		NCOWebtopAvailableFieldsList = new NCOWebtopViewDataList( NCOWebtopAvailableFields );
		NCOWebtopEventListViewList = new NCOWebtopViewDataList( NCOWebtopEventListView );

		NCOWebtopAvailableSortFieldsList = new NCOWebtopViewDataList( NCOWebtopAvailableSortFields );		
		NCOWebtopSortedByList = new NCOWebtopViewDataList( NCOWebtopSortedBy );
	}

	//******************************************************
	function addItems()
	{
		addAvailableViewItems();
		addEventListItems();

		addAvailableSortItems();
		addSortedByItems();

		displaySelected();

		NCOWebtopSelectData[ "eventListView" ] = NCOWebtopEventListViewList;
		NCOWebtopUnusedData[ "eventListView" ] = NCOWebtopAvailableFieldsList;


		NCOWebtopSelectData[ "sortedBy" ] = NCOWebtopSortedByList;
		NCOWebtopUnusedData[ "sortedBy" ] = NCOWebtopAvailableSortFieldsList;
	}


	//******************************************************
	function displaySelected()
	{
		setSelectedEventListViewItem();
		setSelectedSortByItem();
	}

	//******************************************************
	function addSelectedItem( itemName )
	{
		var fromItem = NCOWebtopUnusedData[ itemName ];//document.viewForm.availableFields; 
		var toItem = NCOWebtopSelectData[ itemName ];
		var dataItem = fromItem.removeSelectedItem();
		toItem.addDataItem( dataItem , false , true );
	}

	//******************************************************
	function moveTop( itemName )
	{
		NCOWebtopSelectData[ itemName ].moveToTop();
	}

	//******************************************************
	function moveUp( itemName )
	{
		NCOWebtopSelectData[ itemName ].moveUp();
	}

	//******************************************************
	function moveDown( itemName )
	{
		NCOWebtopSelectData[ itemName ].moveDown();
	}

	//******************************************************
	function moveBottom( itemName )
	{
		NCOWebtopSelectData[ itemName ].moveToBottom();
	}

	//******************************************************
	function removeAllItems( itemName )
	{
		var fromItem = 	NCOWebtopSelectData[ itemName ];
		var toItem = NCOWebtopUnusedData[ itemName ];
		var dataItems = fromItem.removeAllItems();
		toItem.addDataItems( dataItems , true );
	}

	//******************************************************
	function addAllItems( itemName )
	{
		var fromItem = 	NCOWebtopUnusedData[ itemName ];
		var toItem = NCOWebtopSelectData[ itemName ];
		var dataItems = fromItem.removeAllItems();
		toItem.addDataItems( dataItems , false );
	}

	//******************************************************
	function removeSelectedItem( itemName )
	{
		var fromItem = 	NCOWebtopSelectData[ itemName ];
		var toItem = NCOWebtopUnusedData[ itemName ];
		var dataItem = fromItem.removeSelectedItem();
		toItem.addDataItem( dataItem , true , true );		
	}

	//******************************************************
	function setSelectedSortByItem()
	{
		NCOWebtopSortedByList.displaySelectedOption();
	}


	//******************************************************
	function setSelectedEventListViewItem()
	{
		NCOWebtopEventListViewList.displaySelectedOption();
	}

	//******************************************************
	function NCOWebtopViewBuilderDisplaySelected( itemName )
	{
		NCOWebtopSelectData[ itemName ].displaySelectedOption();
	}

	//******************************************************
	// NBS 27918: Enables the select list to remember which element is selected.
	function NCOWebtopViewBuilderUpdateIndex( itemName )
	{
		return NCOWebtopSelectData[ itemName ].updateIndex();
	}

	//******************************************************
	function NCOWebtopViewBuilderUpdateSelected( itemName )
	{
			//NBS28185: Cannot change sort order (asc/desc)
		//Need to update the selected index
		NCOWebtopSelectData[ itemName ].updateIndex();

		return NCOWebtopSelectData[ itemName ].update();
	}

