<%@ page language="java" contentType="text/javascript; charset=utf-8" %>
<%@ include file="../i18n.inc" %>


/******************************************************************************************
 *
 */
function createFilter() {

 var filterForm = window.parent.frames[ 'sidebar' ].filterlist.document.filterForm;

 filterForm.action = '/createFilter.do';
 filterForm.target = 'main';
 filterForm.submit();

 buttonurl = "/filterbuilder/buttonbar.jsp?action=Create";

 buttonframe  = window.parent.frames[ 'buttonbar' ].name;

 window.open(buttonurl, buttonframe);
} 


/******************************************************************************************
 *
 */
function copyFilter() {
  
 var idx = window.parent.frames[ 'sidebar' ].filterlist.document.filterForm.filterlist.selectedIndex;

  if(idx < 0) {
    alert("<fmt:message key="filterscripts.toolbar.noselect" bundle="${langset}"/>");
    return;
  }

  submitFormExec('filterForm',
                 'copyto.jsp',
                 'copy_filter',
		 'main');

}

/******************************************************************************************
 *
 */
function copyFilterToMyDir() {

  var idx = window.parent.frames[ 'sidebar' ].filterlist.document.filterForm.filterlist.selectedIndex;
  if(idx < 0) {
    alert("<fmt:message key="filterscripts.toolbar.noselect" bundle="${langset}"/>");
    return;
  }

 submitFormExec('filterForm',
                '/copyFilter.do',
                'copy_filter',
		'main');

  
 buttonurl = "/filterbuilder/buttonbar.jsp?action=Copy";

 buttonframe  = window.parent.frames[ 'buttonbar' ].name;

 window.open(buttonurl, buttonframe);

}

/******************************************************************************************
 *
 */
function delFilter() {

  // verify that there is a selection to delete in the first place
  var idx = window.parent.frames[ 'sidebar' ].filterlist.document.filterForm.filterlist.selectedIndex;

  var len = window.parent.frames[ 'sidebar' ].filterlist.document.filterForm.filterlist.length;

  if(idx < 0) {
    alert("<fmt:message key="filterscripts.toolbar.noselect" bundle="${langset}"/>");
    return;
  }
  else if(len == 1) {
    alert("<fmt:message key="filterscripts.toolbar.lastfilter" bundle="${langset}"/>");

    return;

  }else	{
    if(!confirm("Are you sure you want to delete filter\n\"" +
                  window.parent.frames[ 'sidebar' ].filterlist.document.filterForm.filterlist.options[idx].value +
                  "\"?")) {
      return;
    }
  }

  var deletefiltername = window.parent.frames[ 'sidebar' ].filterlist.document.filterForm.filterlist.options[idx].value;

  // set deletefilter
  window.parent.frames[ 'sidebar' ].filterlist.document.filterForm.selectedfilter.value = deletefiltername;

  // update selectedfilter to 
  //   1. the row below
  //   2. the row above
  //   3. <blank> (in case of empty list)
  var size = window.parent.frames[ 'sidebar' ].filterlist.document.filterForm.filterlist.options.length;
  if((size - 1) >= (idx+1)) {   // there is an item below the deleted
    window.parent.frames[ 'sidebar' ].filterlist.document.filterForm.selectedfilter.value =
          window.parent.frames[ 'sidebar' ].filterlist.document.filterForm.filterlist.options[idx+1].value;
  }
  else if(idx > 0) {            // there is an item before the deleted
    window.parent.frames[ 'sidebar' ].filterlist.document.filterForm.selectedfilter.value =
          window.parent.frames[ 'sidebar' ].filterlist.document.filterForm.filterlist.options[idx-1].value;
  }
  else {                        // the deleted was the last item in the list
    window.parent.frames[ 'sidebar' ].filterlist.document.filterForm.selectedfilter.value = "";
  }


  // submit   
  submitFormExec('filterForm',
                 '/saveFilter.do?action=Delete',
                 'del_filter',
		 'messages');

  
}

/******************************************************************************************
 * execute action
 */
function submitFormExec(form, href, execute, target) {

  presubmit_updateFilterListItem();

  eval("window.parent.frames[ 'sidebar' ].filterlist.document."+form+".action = href ");
  eval("window.parent.frames[ 'sidebar' ].filterlist.document."+form+".exec.value = execute");
  eval("window.parent.frames[ 'sidebar' ].filterlist.document."+form+".target = '" + target + "'");
  eval("window.parent.frames[ 'sidebar' ].filterlist.document."+form+".submit()");

}

/******************************************************************************************
 * before a submit, need to fill in the hidden values for the filterlistitem#=""
 * to correspond to the current filterlist items
 */
function presubmit_updateFilterListItem() {

  var numitems = window.parent.frames[ 'sidebar' ].filterlist.document.filterForm.filterlist.length;

  var i;
  var itemval;

  for(i = 0; i < numitems; i++) {

    if(window.parent.frames[ 'sidebar' ].filterlist.document.filterForm.filterlist.options[i]) {
      itemval = window.parent.frames[ 'sidebar' ].filterlist.document.filterForm.filterlist.options[i].value;
      if(itemval==null) { itemval = ""; }
    }

  } // endfor i numitems
  
} 
